Botan: Botan::CBC_Decryption Class Reference

Botan 1.10.12

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Private Member Functions | List of all members
Botan::CBC_Decryption Class Reference

`#include <cbc.h>`

Inheritance diagram for Botan::CBC_Decryption:

## Public Member Functions
virtual bool | attachable ()
| CBC_Decryption (BlockCipher *cipher, BlockCipherModePaddingMethod *padding)
| CBC_Decryption (BlockCipher *cipher, BlockCipherModePaddingMethod *padding, const SymmetricKey &key, const InitializationVector &iv)
std::string | name () const
void | set_iv (const InitializationVector &iv)
void | set_key (const SymmetricKey &key)
virtual void | start_msg ()
bool | valid_iv_length (size_t iv_len) const
bool | valid_keylength (size_t key_len) const
| ~CBC_Decryption ()

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Private Member Functions
void | buffer_reset ()
size_t | buffered_block_size () const
size_t | current_position () const

## Detailed Description

CBC Decryption

Definition at line 61 of file cbc.h.

## Constructor & Destructor Documentation

Botan::CBC_Decryption::CBC_Decryption | ( | BlockCipher * | cipher,
|  | BlockCipherModePaddingMethod * | padding
| ) |  |

Definition at line 115 of file cbc.cpp.

References Botan::BlockCipher::block_size(), Botan::Buffered_Filter::buffered_block_size(), Botan::BlockCipherModePaddingMethod::name(), name(), Botan::MemoryRegion< T >::resize(), and Botan::BlockCipherModePaddingMethod::valid_blocksize().

116 :
117 Buffered_Filter(ciph->parallel_bytes(), ciph->block_size()),
118 cipher(ciph), padder(pad)
119 {
120 if(!padder->valid_blocksize(cipher->block_size()))
121 throw Invalid_Block_Size(name(), padder->name());
122
123 state.resize(cipher->block_size());
124 temp.resize(buffered_block_size());
125 }
Botan::BlockCipherModePaddingMethod::name
virtual std::string name() const =0
Botan::MemoryRegion::resize
void resize(size_t n)
Definition: secmem.h:211
Botan::BlockCipherModePaddingMethod::valid_blocksize
virtual bool valid_blocksize(size_t block_size) const =0
Botan::CBC_Decryption::name
std::string name() const
Definition: cbc.cpp:231
Botan::BlockCipher::block_size
virtual size_t block_size() const =0
Botan::Buffered_Filter::Buffered_Filter
Buffered_Filter(size_t block_size, size_t final_minimum)
Definition: buf_filt.cpp:18
Botan::Buffered_Filter::buffered_block_size
size_t buffered_block_size() const
Definition: buf_filt.h:67

Botan::CBC_Decryption::CBC_Decryption | ( | BlockCipher * | cipher,
|  | BlockCipherModePaddingMethod * | padding,
|  | const SymmetricKey & | key,
|  | const InitializationVector & | iv
| ) |  |

Definition at line 130 of file cbc.cpp.

References Botan::BlockCipher::block_size(), Botan::Buffered_Filter::buffered_block_size(), Botan::BlockCipherModePaddingMethod::name(), name(), Botan::MemoryRegion< T >::resize(), set_iv(), set_key(), and Botan::BlockCipherModePaddingMethod::valid_blocksize().

133 :
134 Buffered_Filter(ciph->parallel_bytes(), ciph->block_size()),
135 cipher(ciph), padder(pad)
136 {
137 if(!padder->valid_blocksize(cipher->block_size()))
138 throw Invalid_Block_Size(name(), padder->name());
139
140 state.resize(cipher->block_size());
141 temp.resize(buffered_block_size());
142
143 set_key(key);
144 set_iv(iv);
145 }
Botan::BlockCipherModePaddingMethod::name
virtual std::string name() const =0
Botan::MemoryRegion::resize
void resize(size_t n)
Definition: secmem.h:211
Botan::BlockCipherModePaddingMethod::valid_blocksize
virtual bool valid_blocksize(size_t block_size) const =0
Botan::CBC_Decryption::name
std::string name() const
Definition: cbc.cpp:231
Botan::CBC_Decryption::set_iv
void set_iv(const InitializationVector &iv)
Definition: cbc.cpp:150
Botan::BlockCipher::block_size
virtual size_t block_size() const =0
Botan::CBC_Decryption::set_key
void set_key(const SymmetricKey &key)
Definition: cbc.h:69
Botan::Buffered_Filter::Buffered_Filter
Buffered_Filter(size_t block_size, size_t final_minimum)
Definition: buf_filt.cpp:18
Botan::Buffered_Filter::buffered_block_size
size_t buffered_block_size() const
Definition: buf_filt.h:67

Botan::CBC_Decryption::~CBC_Decryption | ( |  | ) |
| inline

Definition at line 85 of file cbc.h.

85 { delete cipher; delete padder; }

## Member Function Documentation

virtual bool Botan::Filter::attachable | ( |  | ) |
| inlinevirtualinherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

std::string Botan::CBC_Decryption::name | ( |  | ) | const
| virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 231 of file cbc.cpp.

References Botan::Algorithm::name(), and Botan::BlockCipherModePaddingMethod::name().

Referenced by CBC_Decryption(), and set_iv().

232 {
233 return (cipher->name() + "/CBC/" + padder->name());
234 }
Botan::BlockCipherModePaddingMethod::name
virtual std::string name() const =0
Botan::Algorithm::name
virtual std::string name() const =0

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protectedinherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::Filter::end_msg(), Botan::MemoryRegion< T >::size(), Botan::Filter::start_msg(), and Botan::Filter::write().

Referenced by Botan::Base64_Encoder::Base64_Encoder(), Botan::EAX_Decryption::EAX_Decryption(), Botan::PK_Encryptor_Filter::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::PBE_PKCS5v15::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PBE_PKCS5v20::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Hex_Encoder::Hex_Encoder(), Botan::ECB_Encryption::name(), Botan::EAX_Base::name(), Botan::ECB_Decryption::name(), Botan::CTS_Encryption::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::CBC_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), Botan::CTS_Decryption::set_iv(), set_iv(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Zlib_Compression::write(), Botan::Bzip_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:152
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

void Botan::Filter::send | ( | byte | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inlineprotectedinherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

void Botan::CBC_Decryption::set_iv | ( | const InitializationVector & | iv | ) |
| virtual

Set the initialization vector of this filter. Note: you should call set_iv() only after you have called set_key()

Parameters

  iv | the initialization vector to use

Reimplemented from Botan::Keyed_Filter.

Definition at line 150 of file cbc.cpp.

References Botan::OctetString::bits_of(), Botan::BlockCipher::block_size(), Botan::Buffered_Filter::buffer_reset(), Botan::copy_mem(), Botan::BlockCipher::decrypt(), Botan::BlockCipher::decrypt_n(), Botan::Buffered_Filter::end_msg(), Botan::OctetString::length(), name(), Botan::Filter::send(), Botan::MemoryRegion< T >::size(), Botan::BlockCipherModePaddingMethod::unpad(), valid_iv_length(), Botan::Buffered_Filter::write(), and Botan::xor_buf().

Referenced by CBC_Decryption().

151 {
152 if(!valid_iv_length(iv.length()))
153 throw Invalid_IV_Length(name(), iv.length());
154
155 state = iv.bits_of();
156 buffer_reset();
157 }
Botan::CBC_Decryption::name
std::string name() const
Definition: cbc.cpp:231
Botan::Buffered_Filter::buffer_reset
void buffer_reset()
Definition: buf_filt.h:77
Botan::CBC_Decryption::valid_iv_length
bool valid_iv_length(size_t iv_len) const
Definition: cbc.h:74

void Botan::CBC_Decryption::set_key | ( | const SymmetricKey & | key | ) |
| inlinevirtual

Set the key of this filter

Parameters

  key | the key to use

Implements Botan::Keyed_Filter.

Definition at line 69 of file cbc.h.

Referenced by CBC_Decryption().

69 { cipher->set_key(key); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

virtual void Botan::Filter::start_msg | ( |  | ) |
| inlinevirtualinherited

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented in Botan::Zlib_Decompression, Botan::EAX_Base, Botan::Bzip_Decompression, Botan::PBE_PKCS5v20, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, and Botan::Zlib_Compression.

Definition at line 38 of file filter.h.

Referenced by Botan::Filter::send().

38 {}

bool Botan::CBC_Decryption::valid_iv_length | ( | size_t | length | ) | const
| inlinevirtual

Check whether an IV length is valid for this filter

Parameters

  length | the IV length to be checked for validity

Returns
  true if the IV length is valid, false otherwise

Reimplemented from Botan::Keyed_Filter.

Definition at line 74 of file cbc.h.

Referenced by set_iv().

75 { return (iv_len == cipher->block_size()); }
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

bool Botan::CBC_Decryption::valid_keylength | ( | size_t | length | ) | const
| inlinevirtual

Check whether a key length is valid for this filter

Parameters

  length | the key length to be checked for validity

Returns
  true if the key length is valid, false otherwise

Implements Botan::Keyed_Filter.

Definition at line 71 of file cbc.h.

72 { return cipher->valid_keylength(key_len); }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51

The documentation for this class was generated from the following files:

- src/filters/modes/cbc/cbc.h
- src/filters/modes/cbc/cbc.cpp